package it.unibo.tw0708.dao.fake;

import java.util.ArrayList;
import java.util.List;

import it.unibo.tw0708.dao.CompactDiscDAO;
import it.unibo.tw0708.dao.CompactDiscTO;

public class FakeCompactDiscDAO 
implements CompactDiscDAO {

	private List<CompactDiscTO> compactDiscs;

	/**
	 * This is here so that we can use dependency injection to initialize the 'fake-db'
	 * @param compactDiscs
	 */
	public void setCompactDiscs(List<CompactDiscTO> compactDiscs) {
		this.compactDiscs = compactDiscs;
	}

	// -----------------------------------------------------
	
	public List<CompactDiscTO> getCompactDiscs(String username) {
		List<CompactDiscTO> result = new ArrayList<CompactDiscTO>();
		if ( compactDiscs != null && compactDiscs.size() > 0 ) {
			for ( CompactDiscTO compactDisc : compactDiscs ) {
				if ( compactDisc.getOwner().equals(username) ) {
					// We pass detached copies of 'fakely-persisted' objects
					result.add((CompactDiscTO)compactDisc.clone());
				}
			}
		}
		return result;
	}

	public void addCompactDiscs(CompactDiscTO compactDisc) {
		if ( compactDisc == null )
			return;
		if ( compactDiscs == null ) {
			compactDiscs = new ArrayList<CompactDiscTO>();
		}
		// We store unreferenced copies of objects
		compactDiscs.add((CompactDiscTO)compactDisc.clone());
	}

	public void removeCompactDiscs(CompactDiscTO compactDisc) {
		if ( compactDisc == null )
			return;
		if ( compactDiscs == null ) 
			return;
		compactDiscs.remove(compactDisc);
	}

}
